#ifndef __KERNELCLASS__
#define __KERNELCLASS__

class Kernel
{
public:
	Kernel(int n, int m, const int *k, int nor)
	{
		rows=n;
		cols=m;
		ker=new int [n*m];
		for(int j=0;j<n*m;j++)
			ker[j]=k[j];
		norm=nor;
	}
	
	~Kernel()
	{
		delete [] ker;
	}
	
	int get(int r, int c)
	{ return ker[(r+rows/2)*cols+(c+cols/2)]; }

	int getHeight()
	{ return rows; }
	
	int getWidth()
	{ return cols; }
	
	int getNorm()
	{ return norm;}
	
private:
	int rows;
	int cols;
	int *ker;
	int norm;
};

const int GAUSS_KERNEL5x5[]={1,4,7,4,1,
		4,16,26,16,4,
		7,26,41,26,7,
		4,16,26,16,4,
		1,4,7,4,1};

const int GAUSS_KERNEL5x5_NORM=273;

const int GAUSS_KERNEL7x7[]={1,1, 2, 2, 2, 1, 1, 
		1, 2, 2, 4, 2, 2, 1,
		2, 2, 4, 8, 4, 2, 2,
		2, 4, 8, 16, 8, 4, 2,
		2, 2, 4, 8, 4, 2, 2,
		1, 2, 2, 4, 2, 2, 1,
		1, 1, 2, 2, 2, 1, 1};

const int GAUSS_KERNEL7x7_NORM=140;

class GaussianKernel5x5: public Kernel
{
public:
	GaussianKernel5x5(): Kernel(5,5, GAUSS_KERNEL5x5, GAUSS_KERNEL5x5_NORM){}
};

class GaussianKernel7x7: public Kernel
{
public:
	GaussianKernel7x7(): Kernel(7,7, GAUSS_KERNEL7x7, GAUSS_KERNEL7x7_NORM){}
};

#endif
